'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMonoid = getMonoid;


// for any object A in any category C, the set of arrows from A to A
// is a monoid under the composition operation of C


// the set of arrows from A to B
function getMonoid(category) {
  return {
    empty: function empty() {
      return category.id();
    },
    concat: function concat(x, y) {
      return category.compose(x, y);
    }
  };
}

// the set of arrows from A to A