'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.composeKleisli = composeKleisli;

var _HKT = require('./HKT');

// Forwards Kleisli composition.
//
// For example:
//
// ```js
// import * as arr from '../Arr'
//
// const second = a => composeKleisli(maybe, arr.tail, arr.head)
// ```
function composeKleisli(chain, f, g) {
  return function (a) {
    return chain.chain(g, f(a));
  };
}