'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fold = fold;
exports.getAll = getAll;
exports.find = find;
exports.headOption = headOption;

var _Monoid = require('./Monoid');

var _Identity = require('./Identity');

var _Maybe = require('./Maybe');

/** combine all targets using a target's Monoid */
function fold(fold, monoid, s) {
  return fold.foldMap(monoid, _Identity.id, s);
}

/**
 * get all the targets of a [[Fold]]
 */

function getAll(fold, s) {
  return fold.foldMap(_Monoid.arrayMonoid, function (a) {
    return [a];
  }, s);
}

/** find the first target of a [[Fold]] matching the predicate  */
function find(fold, p, s) {
  return fold.foldMap(_Maybe.first, function (a) {
    return p(a) ? (0, _Maybe.of)(a) : _Maybe.Nothing;
  }, s);
}

/** get the first target of a [[Fold]] */
function headOption(fold, s) {
  return find(fold, function () {
    return true;
  }, s);
}